#!/bin/sh

cd `dirname $0`

die () {
  echo "*** regression.sh: $*" 1>&2
  exit 1
}

[ -x mcracetrack ] || die "could not find 'mcracetrack' program"

[ -x check-mcracetrack-solution ] || \
  die "could not find 'check-mcracetrack-solution' program"

[ -f makefile ] || die "could not find 'makefile'"

if [ x"`grep BACKWARD makefile`" = x ]
then
  BACKWARD=""
else
  BACKWARD="--only-backward --only-forward"
fi

cd parcours

run () {
  base=$1
  shift
  expected=$1
  shift
  [ -f $base ] || die "could not find parcours '$base'"
  echo -n $r mcracetrack $* $base 
  ../mcracetrack $* $base >$base.log 2>$base.err
  actual=$?
  echo -n " [$actual]"
  if [ ! $actual = $expected ]
  then
    echo -n "  !! BUT EXPECTED $expected !!"
  else
    ../check-mcracetrack-solution $base $base.log >$base.clog 2>$base.cerr
    res=$?
    if [ $res != 0 ]
    then
      echo -n "  !! CHECK FAILED !!"
    fi
  fi
  echo
  r=`expr $r + 1`
}
r=1

for opt in "" "-g" $BACKWARD
do

run starteqgoal 10 $opt
run onestep1 10 $opt
run negstep1 10 $opt
run onestep2 10 $opt
run onestep3 10 $opt
run twostep1 10 $opt
run twostep2 10 -a 5 $opt
run nostep1 20 -i 10 $opt
run nostep1 20 -a 3 -i 3 $opt
run nostep1 10 -a 2 -i 2 $opt
run nostep1 10 -a 1 -i 1 $opt
run maze1 20 -a 1 $opt
run maze1 20 -a 2 $opt
run points1 10 -a 1 $opt
run maze2 10 $opt
run maze3 10 -a 2 $opt
run hseg1 20 -a 1 $opt
run hseg2 20 -a 2 -i 2 $opt
run maze4 10 -a 1 $opt
run maze5 10 -a 1 $opt
run maze6 10 -a 1 $opt
run maze7 10 -a 1 $opt

done
